<?php

require_once('includes/global.php');

// Nastavení
$xp_from_word = 1;
$index_level = 100;
$from_diakrit = 3; // zvýšené xp za slovo s diakritikou
$FontFile = 'images/FRIZQT__.ttf';

function CheckDiakrit($Word)
{
  $Result = false;
  $Diakrit = array("á","č","ď","é","ě","í","ľ","ň","ó","ř","š","ť","ú",
  "ů","ý","ž","Á","Č","Ď","É","Ě","Í","Ľ","Ň","Ó","Ř","Š","Ť","Ú","Ů","Ý","Ž");
  for($i = 0; $i < count($Diakrit); $i = $i + 1) 
  {
    if(strpos($Word, $Diakrit[$i]) <> false) 
      $Result = true;
  }
  return($Result);
}

function CreateImg($prefix, $user, $xp) 
{
  global $index_level, $FontFile;   
  
  if($xp > 0) 
  {
    $level = sqrt($xp / $index_level);
    $level = substr($level, 0, strpos($level, '.'));
  } else $level = 0;
  $xp_min = $level * $level * $index_level;
  $xp_max = ($level + 1) * ($level + 1) * $index_level;
  $xp_max = $xp_max - $xp_min;
  $xp = $xp - $xp_min;
    
  if($xp_max > 0) $Percent = ( $xp / $xp_max) * 100; 
    else $Percent = 0;
  $Percent = substr($Percent, 0, 5);

  $PercentBar = $Percent * 2.5;
  $Image = ImageCreateTrueColor(250, 15);
  $Color1 = imagecolorallocate($Image, 214, 214, 214);
  $Color2 = imagecolorallocate($Image, 239, 131, 166);
  $Color3 = imagecolorallocate($Image, 225, 0, 0);
  imagefilledrectangle($Image, 0, 0, 250, 15, $Color1);
  imagefilledrectangle($Image, 0, 0, $PercentBar, 59, $Color2);
  ImageTTFText($Image, 11, 0, 10, 12, $Color3, $FontFile, $level.' Level');
  ImageTTFText($Image, 8, 0, 80, 12, $Color3, $FontFile, $xp.'/'.$xp_max.' xp   '.$user);
  
  if(!file_exists('tmp/'.$prefix.'/')) mkdir('tmp/'.$prefix.'/');
  if(!file_exists('tmp/'.$prefix.'/'.$user.'/')) mkdir('tmp/'.$prefix.'/'.$user.'/');
  ImagePNG($Image, 'tmp/'.$prefix.'/'.$user.'/level.png'); 
}

function GetXPFromTranslation($UserId) 
{
  global $System, $TranslationTree, $xp_from_word, $from_diakrit;
  
  $xp = 0;
  foreach($TranslationTree as $Group) 
  { 
    if($Group['TablePrefix'] != '') 
    {
      $GroupBy = 'GROUP BY ';
      foreach($TranslationTree[$Group['Id']]['Items'] as $Index => $TextItem) 
      {  
         $GroupBy .= '`'.$TextItem['Column'].'`, ';
      } 
      $GroupBy = substr($GroupBy, 0, -2);
      
      $IDtran = $System->Database->query('SELECT * FROM `'.$Group['TablePrefix'].'` WHERE (`User` = '.$UserId.') AND (`Complete` = 1) AND (`Take` IS NOT NULL) '.$GroupBy);
      while($Line = $IDtran->fetch_array()) 
      {   
        $DbResult = $System->Database->query('SELECT * FROM `'.$Group['TablePrefix'].'` WHERE `ID` = '.$Line['Take']);
        $LineComparison = $DbResult->fetch_assoc();
        $xp_translation = 0;   
        $translated = true;
        foreach($TranslationTree[$Group['Id']]['Items'] as $Index => $TextItem) 
        { 
          if(($Line[$TextItem['Column']] <> $LineComparison[$TextItem['Column']]) and (strlen($Line[$TextItem['Column']]) > (strlen($LineComparison[$TextItem['Column']]) * 0.5))) 
          {  
            $TextArr = explode(' ', $Line[$TextItem['Column']]);
            foreach($TextArr as $Word) 
            {  
              if(CheckDiakrit($Word)) $indikator = $from_diakrit;
                else $indikator = 1;
              $xp_translation = $xp_translation + ($indikator * $xp_from_word);
            }                                
          } else 
          {
            if (($Line[$TextItem['Column']] == $LineComparison[$TextItem['Column']]) and ('0' == $LineComparison['Language']) and ($LineComparison[$TextItem['Column']] <> '') and ($TextItem['Column'] <> 'ShortCut')) $translated = false;
          }
        }       
        if($translated) $xp = $xp + $xp_translation;   // Přičítání XP za celý překlad, pokud je celý přeložený
      }
    }
  }
  return($xp);
}

function ImgLevelUpdate()
{ 
  global $System, $TranslationTree, $Config;

  // Main code for users
  $DbResult = $System->Database->query('SELECT `ID`, `Name` FROM `User` WHERE `NeedUpdate` = 1');
  while($LineUser = $DbResult->fetch_array()) 
  {
    // Build TranslatedCount query
    $TranslatedCount = '(';
    if(count($TranslationTree) > 0)
    {
	  foreach($TranslationTree as $Group)
      if($Group['TablePrefix'] != '')
      {
        $Count = '(SELECT COUNT(*) FROM `'.$Group['TablePrefix'].'` WHERE (`Complete` = 1) AND (`Language` <> '.
          $Config['OriginalLanguage'].') AND (`User`='.$LineUser['ID'].'))';
        $TranslatedCount .= 'COALESCE('.$Count.', 0) + ';
      }
      $TranslatedCount = substr($TranslatedCount, 0, -3).')';
    } else $TranslatedCount = 0;
    
    $xp = GetXPFromTranslation($LineUser['ID']); 
    $System->Database->query('UPDATE `User` SET `XP` = '.$xp.', `TranslatedCount` = '.$TranslatedCount.' WHERE `User`.`ID` = '.$LineUser['ID']);
    CreateImg('user', $LineUser['Name'], $xp);
  }

  // Main code for translation teams
  $DbResult = $System->Database->query('SELECT `ID`, `Name`, (SELECT AVG(`XP`) FROM `User` WHERE `Team` = `Team`.`Id`) AS `Average` '.
    'FROM `Team` WHERE `ID` IN (SELECT `Team` FROM `User` WHERE `NeedUpdate` = 1)');
  while($LineTeam = $DbResult->fetch_array()) 
  {
    CreateImg('team', $LineTeam['Name'], substr($LineTeam['Average'], 0, strpos($LineTeam['Average'],'.')));  //vytváření obrázku
  }
  $System->Database->query('UPDATE `User` SET `NeedUpdate` = 0');
}

function ImgLevelShow()
{
  global $System;
  
  // Do update for all users
  $System->Database->query('UPDATE `User` SET `NeedUpdate` = 1');
  ImgLevelUpdate();
  
  $Output = '<strong>Uživatelé</strong><br/>';
  $ID = $System->Database->query('SELECT `ID`, `Name` FROM `User`');
  while($LineUser = $ID->fetch_array()) 
  {
    $Output .= '<img src="tmp/user/'.$LineUser['Name'].'/level.png" /> '.$LineUser['Name'].'<br />';
  }

  $Output .= '<br/><strong>Týmy</strong><br/>';
  $ID = $System->Database->query('SELECT `ID`, `Name` FROM `Team`');
  while($LineTeam = $ID->fetch_array()) 
  {
    $Output .= '<img src="tmp/team/'.$LineTeam['Name'].'/level.png" /> '.$LineTeam['Name'].'<br />';
  }
  WriteLog('Přegenerovány obrázky úrovní překladatelů a týmů', LOG_TYPE_ADMINISTRATION);  
  return($Output);
}

?>
